$(() => {
$('#productsSimple').dxTagBox({
items: simpleProducts,
inputAttr: productLabel,
});
$('#productsSearch').dxTagBox({
items: simpleProducts,
searchEnabled: true,
inputAttr: productLabel,
});
$('#productsSelection').dxTagBox({
items: simpleProducts,
showSelectionControls: true,
applyValueMode: 'useButtons',
inputAttr: productLabel,
});
$('#productsHide').dxTagBox({
items: simpleProducts,
hideSelectedItems: true,
inputAttr: productLabel,
});
$('#productsLine').dxTagBox({
items: simpleProducts,
multiline: false,
inputAttr: productLabel,
});
$('#productsEdit').dxTagBox({
items: simpleProducts,
acceptCustomValue: true,
inputAttr: productLabel,
onCustomItemCreating(args) {
const newValue = args.text;
const { component } = args;
const currentItems = component.option('items');
const isItemInDataSource = currentItems.some((item) => item === newValue);
if (!isItemInDataSource) {
currentItems.unshift(newValue);
component.option('items', currentItems);
}
args.customItem = newValue;
},
});
$('#productsPlaceholder').dxTagBox({
items: simpleProducts,
placeholder: 'Choose Product...',
inputAttr: productLabel,
});
$('#productsDisabled').dxTagBox({
items: simpleProducts,
value: [simpleProducts[0]],
disabled: true,
inputAttr: productLabel,
});
$('#productsDataSource').dxTagBox({
dataSource: new DevExpress.data.ArrayStore({
data: products,
key: 'ID',
}),
displayExpr: 'Name',
valueExpr: 'ID',
inputAttr: productLabel,
});
let product = null;
const popoverContentTemplate = function () {
return $('<div>').append(
$(`<p><b>Name: </b><span>${product.Name}</span></p>`),
$(`<p><b>Price: </b><span>$${product.Price}</span></p>`),
$(`<p><b>In-stock: </b><span>${product.Current_Inventory}</span></p>`),
$(`<p><b>Category: </b><span>${product.Category}</span></p>`),
);
};
const popover = $('#popover').dxPopover({}).dxPopover('instance');
$('#productsCustom').dxTagBox({
dataSource: products,
value: [1, 2],
displayExpr: 'Name',
valueExpr: 'ID',
inputAttr: productLabel,
itemTemplate(data) {
return `
<div class='custom-item'>
<img src='${data.ImageSrc}' alt='${data.Name}. Picture' />
<div class='product-name'>${data.Name}</div>
</div>
`;
},
tagTemplate(data) {
const isDisabled = data.Name === 'SuperHD Video Player';
const tagImg = $('<img>', { class: 'tag-img' }).attr({
src: data.ImageSrc,
alt: `${data.Name}. Picture`,
});
const tag = $('<div>')
.attr('aria-disabled', isDisabled)
.addClass(`dx-tag-content ${isDisabled && 'disabled-tag'}`)
.append(
tagImg,
$('<span>').text(data.Name),
!isDisabled && $('<div>').addClass('dx-tag-remove-button'),
);
tag.on('dxhoverstart', (args) => {
product = data;
popover.option({
contentTemplate: () => popoverContentTemplate(),
target: args.target.closest('.dx-tag'),
});
popover.show();
});
tag.on('dxhoverend', () => {
popover.hide();
});
return tag;
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.3/css/dx.light.css" />
<script src="js/dx.all.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="form">
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">Default mode</div>
<div class="dx-field-value">
<div id="productsSimple"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Search mode</div>
<div class="dx-field-value">
<div id="productsSearch"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Batch selection</div>
<div class="dx-field-value">
<div id="productsSelection"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Hide selected items</div>
<div class="dx-field-value">
<div id="productsHide"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Single line mode</div>
<div class="dx-field-value">
<div id="productsLine"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Add custom items</div>
<div class="dx-field-value">
<div id="productsEdit"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">With custom placeholder</div>
<div class="dx-field-value">
<div id="productsPlaceholder"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Disabled</div>
<div class="dx-field-value">
<div id="productsDisabled"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Data source</div>
<div class="dx-field-value">
<div id="productsDataSource"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Custom template</div>
<div class="dx-field-value">
<div id="productsCustom"></div>
<div id="popover"></div>
</div>
</div>
</div>
</div>
</div>
</body>
</html>
body .custom-item {
padding-left: 7px;
padding-right: 7px;
}
.custom-item > img {
height: 30px;
width: 40px;
float: left;
margin-top: 2px;
}
.custom-item > div.product-name {
margin-left: 40px;
line-height: 34px;
font-size: 14px;
}
body .custom-item input {
background-color: transparent;
}
body .dx-popup-content .custom-item {
padding-top: 7px;
padding-bottom: 8px;
}
.dx-popup-content .custom-item > div {
padding-left: 8px;
text-indent: 0;
text-overflow: ellipsis;
overflow: hidden;
}
#productsCustom .dx-tag-content {
display: flex;
align-items: center;
}
#productsCustom .tag-img {
height: 30px;
margin-right: 5px;
}
#productsCustom .dx-tag-content.disabled-tag {
padding-right: 6px;
opacity: 0.5;
cursor: not-allowed;
}
const simpleProducts = [
'HD Video Player',
'SuperHD Video Player',
'SuperPlasma 50',
'SuperLED 50',
'SuperLED 42',
'SuperLCD 55',
'SuperLCD 42',
'SuperPlasma 65',
'SuperLCD 70',
'Projector Plus',
'Projector PlusHT',
'ExcelRemote IR',
'ExcelRemote Bluetooth',
'ExcelRemote IP',
];
const products = [{
ID: 1,
Name: 'HD Video Player',
Price: 330,
Current_Inventory: 225,
Backorder: 0,
Manufacturing: 10,
Category: 'Video Players',
ImageSrc: '../../../../images/products/1.png',
}, {
ID: 2,
Name: 'SuperHD Video Player',
Price: 400,
Current_Inventory: 150,
Backorder: 0,
Manufacturing: 25,
Category: 'Video Players',
ImageSrc: '../../../../images/products/2.png',
}, {
ID: 3,
Name: 'SuperPlasma 50',
Price: 2400,
Current_Inventory: 0,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
ImageSrc: '../../../../images/products/3.png',
}, {
ID: 4,
Name: 'SuperLED 50',
Price: 1600,
Current_Inventory: 77,
Backorder: 0,
Manufacturing: 55,
Category: 'Televisions',
ImageSrc: '../../../../images/products/4.png',
}, {
ID: 5,
Name: 'SuperLED 42',
Price: 1450,
Current_Inventory: 445,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
ImageSrc: '../../../../images/products/5.png',
}, {
ID: 6,
Name: 'SuperLCD 55',
Price: 1350,
Current_Inventory: 345,
Backorder: 0,
Manufacturing: 5,
Category: 'Televisions',
ImageSrc: '../../../../images/products/6.png',
}, {
ID: 7,
Name: 'SuperLCD 42',
Price: 1200,
Current_Inventory: 210,
Backorder: 0,
Manufacturing: 20,
Category: 'Televisions',
ImageSrc: '../../../../images/products/7.png',
}, {
ID: 8,
Name: 'SuperPlasma 65',
Price: 3500,
Current_Inventory: 0,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
ImageSrc: '../../../../images/products/8.png',
}, {
ID: 9,
Name: 'SuperLCD 70',
Price: 4000,
Current_Inventory: 95,
Backorder: 0,
Manufacturing: 5,
Category: 'Televisions',
ImageSrc: '../../../../images/products/9.png',
}, {
ID: 10,
Name: 'DesktopLED 21',
Price: 175,
Current_Inventory: null,
Backorder: 425,
Manufacturing: 75,
Category: 'Monitors',
ImageSrc: '../../../../images/products/10.png',
}, {
ID: 12,
Name: 'DesktopLCD 21',
Price: 170,
Current_Inventory: 210,
Backorder: 0,
Manufacturing: 60,
Category: 'Monitors',
ImageSrc: '../../../../images/products/12.png',
}, {
ID: 13,
Name: 'DesktopLCD 19',
Price: 160,
Current_Inventory: 150,
Backorder: 0,
Manufacturing: 210,
Category: 'Monitors',
ImageSrc: '../../../../images/products/13.png',
}, {
ID: 14,
Name: 'Projector Plus',
Price: 550,
Current_Inventory: null,
Backorder: 55,
Manufacturing: 10,
Category: 'Projectors',
ImageSrc: '../../../../images/products/14.png',
}, {
ID: 15,
Name: 'Projector PlusHD',
Price: 750,
Current_Inventory: 110,
Backorder: 0,
Manufacturing: 90,
Category: 'Projectors',
ImageSrc: '../../../../images/products/15.png',
}, {
ID: 16,
Name: 'Projector PlusHT',
Price: 1050,
Current_Inventory: 0,
Backorder: 75,
Manufacturing: 57,
Category: 'Projectors',
ImageSrc: '../../../../images/products/16.png',
}, {
ID: 17,
Name: 'ExcelRemote IR',
Price: 150,
Current_Inventory: 650,
Backorder: 0,
Manufacturing: 190,
Category: 'Automation',
ImageSrc: '../../../../images/products/17.png',
}, {
ID: 18,
Name: 'ExcelRemote Bluetooth',
Price: 180,
Current_Inventory: 310,
Backorder: 0,
Manufacturing: 0,
Category: 'Automation',
ImageSrc: '../../../../images/products/18.png',
}, {
ID: 19,
Name: 'ExcelRemote IP',
Price: 200,
Current_Inventory: 0,
Backorder: 325,
Manufacturing: 225,
Category: 'Automation',
ImageSrc: '../../../../images/products/19.png',
}];
const productLabel = { 'aria-label': 'Product' };

<template>
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">Default mode</div>
<div class="dx-field-value">
<DxTagBox
:items="simpleProducts"
:input-attr="{ 'aria-label': 'Product' }"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Search mode</div>
<div class="dx-field-value">
<DxTagBox
:items="simpleProducts"
:search-enabled="true"
:input-attr="{ 'aria-label': 'Product' }"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Batch selection</div>
<div class="dx-field-value">
<DxTagBox
:items="simpleProducts"
:show-selection-controls="true"
:input-attr="{ 'aria-label': 'Product' }"
apply-value-mode="useButtons"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Hide selected items</div>
<div class="dx-field-value">
<DxTagBox
:items="simpleProducts"
:input-attr="{ 'aria-label': 'Product' }"
:hide-selected-items="true"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Single line mode</div>
<div class="dx-field-value">
<DxTagBox
:items="simpleProducts"
:input-attr="{ 'aria-label': 'Product' }"
:multiline="false"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Add custom items</div>
<div class="dx-field-value">
<DxTagBox
:items="editableProducts"
:accept-custom-value="true"
:input-attr="{ 'aria-label': 'Product' }"
@customItemCreating="onCustomItemCreating"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">With custom placeholder</div>
<div class="dx-field-value">
<DxTagBox
:items="simpleProducts"
:input-attr="{ 'aria-label': 'Product' }"
placeholder="Choose Product..."
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Disabled</div>
<div class="dx-field-value">
<DxTagBox
:items="simpleProducts"
:input-attr="{ 'aria-label': 'Product' }"
:value="[simpleProducts[0]]"
:disabled="true"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Data source</div>
<div class="dx-field-value">
<DxTagBox
:data-source="products"
:input-attr="{ 'aria-label': 'Product' }"
display-expr="Name"
value-expr="Id"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Custom template</div>
<div class="dx-field-value">
<DxTagBox
:data-source="products"
:value="value"
:input-attr="{ 'aria-label': 'Product' }"
display-expr="Name"
value-expr="Id"
item-template="item"
tag-template="tag"
>
<template #item="{ data }">
<Item :item-data="data"/>
</template>
<template #tag="{ data }">
<Tag :tag-data="data"/>
</template>
</DxTagBox>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxTagBox, { type DxTagBoxTypes } from 'devextreme-vue/tag-box';
import Item from './Item.vue';
import Tag from './Tag.vue';
import { simpleProducts, products } from './data.ts';
const editableProducts = ref(simpleProducts.slice());
const value = ref([1, 2]);
const onCustomItemCreating = ref((args: DxTagBoxTypes.CustomItemCreatingEvent) => {
const newValue = args.text;
const isItemInDataSource = editableProducts.value.some((item) => item === newValue);
if (!isItemInDataSource && newValue) {
editableProducts.value = [newValue, ...editableProducts.value];
}
args.customItem = newValue;
});
</script>
<style scoped>
body .custom-item {
padding-left: 7px;
padding-right: 7px;
}
.custom-item > img {
height: 30px;
width: 40px;
float: left;
margin-top: 2px;
}
.custom-item > div.product-name {
margin-left: 40px;
line-height: 34px;
font-size: 14px;
}
body .custom-item input {
background-color: transparent;
}
body .dx-popup-content .custom-item {
padding-top: 7px;
padding-bottom: 8px;
}
.dx-popup-content .custom-item > div {
padding-left: 8px;
text-indent: 0;
text-overflow: ellipsis;
overflow: hidden;
}
</style>
<template>
<div class="custom-item">
<img
:src="itemData.ImageSrc"
:alt="`${itemData.Name}. Picture`"
>
<div class="product-name">
{{ itemData.Name }}
</div>
</div>
</template>
<script setup lang="ts">
withDefaults(defineProps<{
itemData?: { [key: string]: string }
}>(), {
itemData: () => ({ Name: '' }),
});
</script>
<template>
<div>
<div
ref="target"
:class="{'dx-tag-content': true, 'disabled-tag': isDisabled}"
:aria-disabled="isDisabled"
@mouseenter="show = true"
@mouseleave="show = false"
>
<img
:src="tagData.ImageSrc"
:alt="`${tagData.Name}. Picture`"
class="tag-img"
>
<span>{{ tagData.Name }}</span>
<div
v-if="!isDisabled"
class="dx-tag-remove-button"
/>
</div>
<DxPopover
:visible="show"
:target="target"
>
<p>
<b>Name: </b><span>{{ tagData.Name }}</span>
</p>
<p>
<b>Price: </b><span>{{ tagData.Price }}</span>
</p>
<p>
<b>In-stock: </b><span>{{ tagData.Current_Inventory }}</span>
</p>
<p>
<b>Category: </b><span>{{ tagData.Category }}</span>
</p>
</DxPopover>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxPopover from 'devextreme-vue/popover';
type TagData = Record<string, string>;
const props = withDefaults(defineProps<{
tagData?: TagData
}>(), {
tagData: () => ({} as TagData),
});
const isDisabled = ref(props.tagData.Name === 'SuperHD Video Player');
const show = ref(false);
const target = ref(null);
</script>
<style scoped>
.dx-tag-content {
display: flex;
align-items: center;
}
.tag-img {
height: 30px;
margin-right: 5px;
}
.dx-tag-content.disabled-tag {
padding-right: 6px;
opacity: 0.5;
cursor: not-allowed;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
export const simpleProducts = [
'HD Video Player',
'SuperHD Video Player',
'SuperPlasma 50',
'SuperLED 50',
'SuperLED 42',
'SuperLCD 55',
'SuperLCD 42',
'SuperPlasma 65',
'SuperLCD 70',
'Projector Plus',
'Projector PlusHT',
'ExcelRemote IR',
'ExcelRemote Bluetooth',
'ExcelRemote IP',
];
export const products = [{
Id: 1,
Name: 'HD Video Player',
Price: 330,
Current_Inventory: 225,
Backorder: 0,
Manufacturing: 10,
Category: 'Video Players',
ImageSrc: '../../../../images/products/1.png',
}, {
Id: 2,
Name: 'SuperHD Video Player',
Price: 400,
Current_Inventory: 150,
Backorder: 0,
Manufacturing: 25,
Category: 'Video Players',
ImageSrc: '../../../../images/products/2.png',
}, {
Id: 3,
Name: 'SuperPlasma 50',
Price: 2400,
Current_Inventory: 0,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
ImageSrc: '../../../../images/products/3.png',
}, {
Id: 4,
Name: 'SuperLED 50',
Price: 1600,
Current_Inventory: 77,
Backorder: 0,
Manufacturing: 55,
Category: 'Televisions',
ImageSrc: '../../../../images/products/4.png',
}, {
Id: 5,
Name: 'SuperLED 42',
Price: 1450,
Current_Inventory: 445,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
ImageSrc: '../../../../images/products/5.png',
}, {
Id: 6,
Name: 'SuperLCD 55',
Price: 1350,
Current_Inventory: 345,
Backorder: 0,
Manufacturing: 5,
Category: 'Televisions',
ImageSrc: '../../../../images/products/6.png',
}, {
Id: 7,
Name: 'SuperLCD 42',
Price: 1200,
Current_Inventory: 210,
Backorder: 0,
Manufacturing: 20,
Category: 'Televisions',
ImageSrc: '../../../../images/products/7.png',
}, {
Id: 8,
Name: 'SuperPlasma 65',
Price: 3500,
Current_Inventory: 0,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
ImageSrc: '../../../../images/products/8.png',
}, {
Id: 9,
Name: 'SuperLCD 70',
Price: 4000,
Current_Inventory: 95,
Backorder: 0,
Manufacturing: 5,
Category: 'Televisions',
ImageSrc: '../../../../images/products/9.png',
}, {
Id: 10,
Name: 'DesktopLED 21',
Price: 175,
Current_Inventory: null,
Backorder: 425,
Manufacturing: 75,
Category: 'Monitors',
ImageSrc: '../../../../images/products/10.png',
}, {
Id: 12,
Name: 'DesktopLCD 21',
Price: 170,
Current_Inventory: 210,
Backorder: 0,
Manufacturing: 60,
Category: 'Monitors',
ImageSrc: '../../../../images/products/12.png',
}, {
Id: 13,
Name: 'DesktopLCD 19',
Price: 160,
Current_Inventory: 150,
Backorder: 0,
Manufacturing: 210,
Category: 'Monitors',
ImageSrc: '../../../../images/products/13.png',
}, {
Id: 14,
Name: 'Projector Plus',
Price: 550,
Current_Inventory: null,
Backorder: 55,
Manufacturing: 10,
Category: 'Projectors',
ImageSrc: '../../../../images/products/14.png',
}, {
Id: 15,
Name: 'Projector PlusHD',
Price: 750,
Current_Inventory: 110,
Backorder: 0,
Manufacturing: 90,
Category: 'Projectors',
ImageSrc: '../../../../images/products/15.png',
}, {
Id: 16,
Name: 'Projector PlusHT',
Price: 1050,
Current_Inventory: 0,
Backorder: 75,
Manufacturing: 57,
Category: 'Projectors',
ImageSrc: '../../../../images/products/16.png',
}, {
Id: 17,
Name: 'ExcelRemote IR',
Price: 150,
Current_Inventory: 650,
Backorder: 0,
Manufacturing: 190,
Category: 'Automation',
ImageSrc: '../../../../images/products/17.png',
}, {
Id: 18,
Name: 'ExcelRemote Bluetooth',
Price: 180,
Current_Inventory: 310,
Backorder: 0,
Manufacturing: 0,
Category: 'Automation',
ImageSrc: '../../../../images/products/18.png',
}, {
Id: 19,
Name: 'ExcelRemote IP',
Price: 200,
Current_Inventory: 0,
Backorder: 325,
Manufacturing: 225,
Category: 'Automation',
ImageSrc: '../../../../images/products/19.png',
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

import React, { useCallback, useState } from 'react';
import TagBox, { type TagBoxTypes } from 'devextreme-react/tag-box';
import Popover from 'devextreme-react/popover';
import { ArrayStore } from 'devextreme-react/common/data';
import Item from './Item.tsx';
import Tag from './Tag.tsx';
import { simpleProducts, products, productLabel } from './data.ts';
import type { Product } from './types.ts';
const disabledValue: string[] = [simpleProducts[0]];
const value: number[] = [1, 2];
const dataSource = new ArrayStore({
data: products,
key: 'Id',
});
function App() {
const [editableProducts, setEditableProducts] = useState<string[]>([...simpleProducts]);
const [target, setTarget] = useState<HTMLElement>();
const [product, setProduct] = useState<Product | null>(null);
const onCustomItemCreating = useCallback(
(args: TagBoxTypes.CustomItemCreatingEvent): void => {
const newValue = args.text;
const isItemInDataSource = editableProducts.some((item: string): boolean => item === newValue);
if (!isItemInDataSource && newValue) {
setEditableProducts([newValue, ...editableProducts]);
}
args.customItem = newValue;
},
[editableProducts],
);
const onMouseEnter = useCallback((e: React.MouseEvent<HTMLElement>, newProduct: Product): void => {
setTarget(e.currentTarget);
setProduct(newProduct);
}, []);
const getAltText = useCallback((text: string): string => `${text}. Picture`, []);
return (
<>
<div className="dx-fieldset">
<div className="dx-field">
<div className="dx-field-label">Default mode</div>
<div className="dx-field-value">
<TagBox
items={simpleProducts}
inputAttr={productLabel}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Search mode</div>
<div className="dx-field-value">
<TagBox
items={simpleProducts}
searchEnabled={true}
inputAttr={productLabel}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Batch selection</div>
<div className="dx-field-value">
<TagBox
items={simpleProducts}
showSelectionControls={true}
inputAttr={productLabel}
applyValueMode="useButtons"
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Hide selected items</div>
<div className="dx-field-value">
<TagBox
items={simpleProducts}
inputAttr={productLabel}
hideSelectedItems={true}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Single line mode</div>
<div className="dx-field-value">
<TagBox
items={simpleProducts}
inputAttr={productLabel}
multiline={false}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Add custom items</div>
<div className="dx-field-value">
<TagBox
items={editableProducts}
inputAttr={productLabel}
acceptCustomValue={true}
onCustomItemCreating={onCustomItemCreating}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">With custom placeholder</div>
<div className="dx-field-value">
<TagBox
items={simpleProducts}
inputAttr={productLabel}
placeholder="Choose Product..."
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Disabled</div>
<div className="dx-field-value">
<TagBox
items={simpleProducts}
inputAttr={productLabel}
value={disabledValue}
disabled={true}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Data source</div>
<div className="dx-field-value">
<TagBox
dataSource={dataSource}
inputAttr={productLabel}
displayExpr="Name"
valueExpr="Id"
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Custom template</div>
<div className="dx-field-value">
<TagBox
dataSource={dataSource}
defaultValue={value}
inputAttr={productLabel}
displayExpr="Name"
valueExpr="Id"
itemRender={(data) => (
<Item
data={data}
getAltText={getAltText}
/>
)}
tagRender={(data) => (
<Tag
product={data}
onMouseEnter={onMouseEnter}
getAltText={getAltText}
/>
)}
/>
<Popover
showEvent="mouseenter"
hideEvent="mouseleave"
target={target}
>
<p>
<b>Name: </b>
<span>{product?.Name}</span>
</p>
<p>
<b>Price: </b>
<span>{product?.Price}</span>
</p>
<p>
<b>In-stock: </b>
<span>{product?.Current_Inventory}</span>
</p>
<p>
<b>Category: </b>
<span>{product?.Category}</span>
</p>
</Popover>
</div>
</div>
</div>
</>
);
}
export default App;
import React, { useCallback, useState } from 'react';
import TagBox from 'devextreme-react/tag-box';
import Popover from 'devextreme-react/popover';
import { ArrayStore } from 'devextreme-react/common/data';
import Item from './Item.js';
import Tag from './Tag.js';
import { simpleProducts, products, productLabel } from './data.js';
const disabledValue = [simpleProducts[0]];
const value = [1, 2];
const dataSource = new ArrayStore({
data: products,
key: 'Id',
});
function App() {
const [editableProducts, setEditableProducts] = useState([...simpleProducts]);
const [target, setTarget] = useState();
const [product, setProduct] = useState(null);
const onCustomItemCreating = useCallback(
(args) => {
const newValue = args.text;
const isItemInDataSource = editableProducts.some((item) => item === newValue);
if (!isItemInDataSource && newValue) {
setEditableProducts([newValue, ...editableProducts]);
}
args.customItem = newValue;
},
[editableProducts],
);
const onMouseEnter = useCallback((e, newProduct) => {
setTarget(e.currentTarget);
setProduct(newProduct);
}, []);
const getAltText = useCallback((text) => `${text}. Picture`, []);
return (
<>
<div className="dx-fieldset">
<div className="dx-field">
<div className="dx-field-label">Default mode</div>
<div className="dx-field-value">
<TagBox
items={simpleProducts}
inputAttr={productLabel}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Search mode</div>
<div className="dx-field-value">
<TagBox
items={simpleProducts}
searchEnabled={true}
inputAttr={productLabel}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Batch selection</div>
<div className="dx-field-value">
<TagBox
items={simpleProducts}
showSelectionControls={true}
inputAttr={productLabel}
applyValueMode="useButtons"
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Hide selected items</div>
<div className="dx-field-value">
<TagBox
items={simpleProducts}
inputAttr={productLabel}
hideSelectedItems={true}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Single line mode</div>
<div className="dx-field-value">
<TagBox
items={simpleProducts}
inputAttr={productLabel}
multiline={false}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Add custom items</div>
<div className="dx-field-value">
<TagBox
items={editableProducts}
inputAttr={productLabel}
acceptCustomValue={true}
onCustomItemCreating={onCustomItemCreating}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">With custom placeholder</div>
<div className="dx-field-value">
<TagBox
items={simpleProducts}
inputAttr={productLabel}
placeholder="Choose Product..."
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Disabled</div>
<div className="dx-field-value">
<TagBox
items={simpleProducts}
inputAttr={productLabel}
value={disabledValue}
disabled={true}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Data source</div>
<div className="dx-field-value">
<TagBox
dataSource={dataSource}
inputAttr={productLabel}
displayExpr="Name"
valueExpr="Id"
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Custom template</div>
<div className="dx-field-value">
<TagBox
dataSource={dataSource}
defaultValue={value}
inputAttr={productLabel}
displayExpr="Name"
valueExpr="Id"
itemRender={(data) => (
<Item
data={data}
getAltText={getAltText}
/>
)}
tagRender={(data) => (
<Tag
product={data}
onMouseEnter={onMouseEnter}
getAltText={getAltText}
/>
)}
/>
<Popover
showEvent="mouseenter"
hideEvent="mouseleave"
target={target}
>
<p>
<b>Name: </b>
<span>{product?.Name}</span>
</p>
<p>
<b>Price: </b>
<span>{product?.Price}</span>
</p>
<p>
<b>In-stock: </b>
<span>{product?.Current_Inventory}</span>
</p>
<p>
<b>Category: </b>
<span>{product?.Category}</span>
</p>
</Popover>
</div>
</div>
</div>
</>
);
}
export default App;
import React from 'react';
import type { Product } from './types.ts';
interface ItemProps {
data: Product;
getAltText: (text: string) => string;
}
export default function Item({ data, getAltText }: ItemProps) {
return (
<div className="custom-item">
<img
src={data.ImageSrc}
alt={getAltText(data.Name)}
/>
<div className="product-name">{data.Name}</div>
</div>
);
}
import React from 'react';
import type { Product } from './types.ts';
interface TagProps {
product: Product;
onMouseEnter: (e: React.MouseEvent<HTMLElement>, product: Product) => void;
getAltText: (text: string) => string;
}
export default function Tag({ product, onMouseEnter, getAltText }: TagProps) {
const isDisabled = product.Name === 'SuperHD Video Player';
return (
<>
<div
className={`dx-tag-content ${isDisabled && 'disabled-tag'}`}
onMouseEnter={(e: React.MouseEvent<HTMLElement>): void => onMouseEnter(e, product)}
aria-disabled={isDisabled}
>
<img
src={product.ImageSrc}
alt={getAltText(product.Name)}
className="tag-img"
/>
<span>{product.Name}</span>
{!isDisabled && <div className="dx-tag-remove-button"></div>}
</div>
</>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(<App />, document.getElementById('app'));
import type { Product } from './types.ts';
export const simpleProducts: string[] = [
'HD Video Player',
'SuperHD Video Player',
'SuperPlasma 50',
'SuperLED 50',
'SuperLED 42',
'SuperLCD 55',
'SuperLCD 42',
'SuperPlasma 65',
'SuperLCD 70',
'Projector Plus',
'Projector PlusHT',
'ExcelRemote IR',
'ExcelRemote Bluetooth',
'ExcelRemote IP',
];
export const products: Product[] = [{
Id: 1,
Name: 'HD Video Player',
Price: 330,
Current_Inventory: 225,
Backorder: 0,
Manufacturing: 10,
Category: 'Video Players',
ImageSrc: '../../../../images/products/1.png',
}, {
Id: 2,
Name: 'SuperHD Video Player',
Price: 400,
Current_Inventory: 150,
Backorder: 0,
Manufacturing: 25,
Category: 'Video Players',
ImageSrc: '../../../../images/products/2.png',
}, {
Id: 3,
Name: 'SuperPlasma 50',
Price: 2400,
Current_Inventory: 0,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
ImageSrc: '../../../../images/products/3.png',
}, {
Id: 4,
Name: 'SuperLED 50',
Price: 1600,
Current_Inventory: 77,
Backorder: 0,
Manufacturing: 55,
Category: 'Televisions',
ImageSrc: '../../../../images/products/4.png',
}, {
Id: 5,
Name: 'SuperLED 42',
Price: 1450,
Current_Inventory: 445,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
ImageSrc: '../../../../images/products/5.png',
}, {
Id: 6,
Name: 'SuperLCD 55',
Price: 1350,
Current_Inventory: 345,
Backorder: 0,
Manufacturing: 5,
Category: 'Televisions',
ImageSrc: '../../../../images/products/6.png',
}, {
Id: 7,
Name: 'SuperLCD 42',
Price: 1200,
Current_Inventory: 210,
Backorder: 0,
Manufacturing: 20,
Category: 'Televisions',
ImageSrc: '../../../../images/products/7.png',
}, {
Id: 8,
Name: 'SuperPlasma 65',
Price: 3500,
Current_Inventory: 0,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
ImageSrc: '../../../../images/products/8.png',
}, {
Id: 9,
Name: 'SuperLCD 70',
Price: 4000,
Current_Inventory: 95,
Backorder: 0,
Manufacturing: 5,
Category: 'Televisions',
ImageSrc: '../../../../images/products/9.png',
}, {
Id: 10,
Name: 'DesktopLED 21',
Price: 175,
Current_Inventory: null,
Backorder: 425,
Manufacturing: 75,
Category: 'Monitors',
ImageSrc: '../../../../images/products/10.png',
}, {
Id: 12,
Name: 'DesktopLCD 21',
Price: 170,
Current_Inventory: 210,
Backorder: 0,
Manufacturing: 60,
Category: 'Monitors',
ImageSrc: '../../../../images/products/12.png',
}, {
Id: 13,
Name: 'DesktopLCD 19',
Price: 160,
Current_Inventory: 150,
Backorder: 0,
Manufacturing: 210,
Category: 'Monitors',
ImageSrc: '../../../../images/products/13.png',
}, {
Id: 14,
Name: 'Projector Plus',
Price: 550,
Current_Inventory: null,
Backorder: 55,
Manufacturing: 10,
Category: 'Projectors',
ImageSrc: '../../../../images/products/14.png',
}, {
Id: 15,
Name: 'Projector PlusHD',
Price: 750,
Current_Inventory: 110,
Backorder: 0,
Manufacturing: 90,
Category: 'Projectors',
ImageSrc: '../../../../images/products/15.png',
}, {
Id: 16,
Name: 'Projector PlusHT',
Price: 1050,
Current_Inventory: 0,
Backorder: 75,
Manufacturing: 57,
Category: 'Projectors',
ImageSrc: '../../../../images/products/16.png',
}, {
Id: 17,
Name: 'ExcelRemote IR',
Price: 150,
Current_Inventory: 650,
Backorder: 0,
Manufacturing: 190,
Category: 'Automation',
ImageSrc: '../../../../images/products/17.png',
}, {
Id: 18,
Name: 'ExcelRemote Bluetooth',
Price: 180,
Current_Inventory: 310,
Backorder: 0,
Manufacturing: 0,
Category: 'Automation',
ImageSrc: '../../../../images/products/18.png',
}, {
Id: 19,
Name: 'ExcelRemote IP',
Price: 200,
Current_Inventory: 0,
Backorder: 325,
Manufacturing: 225,
Category: 'Automation',
ImageSrc: '../../../../images/products/19.png',
}];
export const productLabel = { 'aria-label': 'Product' };
export type Product = {
Id: number,
Name: string,
Price: number,
Current_Inventory: number | null,
Backorder: number,
Manufacturing: number,
Category: string,
ImageSrc: string,
};
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'demo-ts-shared': 'project:utils/demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
export default function Item({ data, getAltText }) {
return (
<div className="custom-item">
<img
src={data.ImageSrc}
alt={getAltText(data.Name)}
/>
<div className="product-name">{data.Name}</div>
</div>
);
}
import React from 'react';
export default function Tag({ product, onMouseEnter, getAltText }) {
const isDisabled = product.Name === 'SuperHD Video Player';
return (
<>
<div
className={`dx-tag-content ${isDisabled && 'disabled-tag'}`}
onMouseEnter={(e) => onMouseEnter(e, product)}
aria-disabled={isDisabled}
>
<img
src={product.ImageSrc}
alt={getAltText(product.Name)}
className="tag-img"
/>
<span>{product.Name}</span>
{!isDisabled && <div className="dx-tag-remove-button"></div>}
</div>
</>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const simpleProducts = [
'HD Video Player',
'SuperHD Video Player',
'SuperPlasma 50',
'SuperLED 50',
'SuperLED 42',
'SuperLCD 55',
'SuperLCD 42',
'SuperPlasma 65',
'SuperLCD 70',
'Projector Plus',
'Projector PlusHT',
'ExcelRemote IR',
'ExcelRemote Bluetooth',
'ExcelRemote IP',
];
export const products = [
{
Id: 1,
Name: 'HD Video Player',
Price: 330,
Current_Inventory: 225,
Backorder: 0,
Manufacturing: 10,
Category: 'Video Players',
ImageSrc: '../../../../images/products/1.png',
},
{
Id: 2,
Name: 'SuperHD Video Player',
Price: 400,
Current_Inventory: 150,
Backorder: 0,
Manufacturing: 25,
Category: 'Video Players',
ImageSrc: '../../../../images/products/2.png',
},
{
Id: 3,
Name: 'SuperPlasma 50',
Price: 2400,
Current_Inventory: 0,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
ImageSrc: '../../../../images/products/3.png',
},
{
Id: 4,
Name: 'SuperLED 50',
Price: 1600,
Current_Inventory: 77,
Backorder: 0,
Manufacturing: 55,
Category: 'Televisions',
ImageSrc: '../../../../images/products/4.png',
},
{
Id: 5,
Name: 'SuperLED 42',
Price: 1450,
Current_Inventory: 445,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
ImageSrc: '../../../../images/products/5.png',
},
{
Id: 6,
Name: 'SuperLCD 55',
Price: 1350,
Current_Inventory: 345,
Backorder: 0,
Manufacturing: 5,
Category: 'Televisions',
ImageSrc: '../../../../images/products/6.png',
},
{
Id: 7,
Name: 'SuperLCD 42',
Price: 1200,
Current_Inventory: 210,
Backorder: 0,
Manufacturing: 20,
Category: 'Televisions',
ImageSrc: '../../../../images/products/7.png',
},
{
Id: 8,
Name: 'SuperPlasma 65',
Price: 3500,
Current_Inventory: 0,
Backorder: 0,
Manufacturing: 0,
Category: 'Televisions',
ImageSrc: '../../../../images/products/8.png',
},
{
Id: 9,
Name: 'SuperLCD 70',
Price: 4000,
Current_Inventory: 95,
Backorder: 0,
Manufacturing: 5,
Category: 'Televisions',
ImageSrc: '../../../../images/products/9.png',
},
{
Id: 10,
Name: 'DesktopLED 21',
Price: 175,
Current_Inventory: null,
Backorder: 425,
Manufacturing: 75,
Category: 'Monitors',
ImageSrc: '../../../../images/products/10.png',
},
{
Id: 12,
Name: 'DesktopLCD 21',
Price: 170,
Current_Inventory: 210,
Backorder: 0,
Manufacturing: 60,
Category: 'Monitors',
ImageSrc: '../../../../images/products/12.png',
},
{
Id: 13,
Name: 'DesktopLCD 19',
Price: 160,
Current_Inventory: 150,
Backorder: 0,
Manufacturing: 210,
Category: 'Monitors',
ImageSrc: '../../../../images/products/13.png',
},
{
Id: 14,
Name: 'Projector Plus',
Price: 550,
Current_Inventory: null,
Backorder: 55,
Manufacturing: 10,
Category: 'Projectors',
ImageSrc: '../../../../images/products/14.png',
},
{
Id: 15,
Name: 'Projector PlusHD',
Price: 750,
Current_Inventory: 110,
Backorder: 0,
Manufacturing: 90,
Category: 'Projectors',
ImageSrc: '../../../../images/products/15.png',
},
{
Id: 16,
Name: 'Projector PlusHT',
Price: 1050,
Current_Inventory: 0,
Backorder: 75,
Manufacturing: 57,
Category: 'Projectors',
ImageSrc: '../../../../images/products/16.png',
},
{
Id: 17,
Name: 'ExcelRemote IR',
Price: 150,
Current_Inventory: 650,
Backorder: 0,
Manufacturing: 190,
Category: 'Automation',
ImageSrc: '../../../../images/products/17.png',
},
{
Id: 18,
Name: 'ExcelRemote Bluetooth',
Price: 180,
Current_Inventory: 310,
Backorder: 0,
Manufacturing: 0,
Category: 'Automation',
ImageSrc: '../../../../images/products/18.png',
},
{
Id: 19,
Name: 'ExcelRemote IP',
Price: 200,
Current_Inventory: 0,
Backorder: 325,
Manufacturing: 225,
Category: 'Automation',
ImageSrc: '../../../../images/products/19.png',
},
];
export const productLabel = { 'aria-label': 'Product' };
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
body .custom-item {
padding-left: 7px;
padding-right: 7px;
}
.custom-item > img {
height: 30px;
width: 40px;
float: left;
margin-top: 2px;
}
.custom-item > div.product-name {
margin-left: 40px;
line-height: 34px;
font-size: 14px;
}
body .custom-item input {
background-color: transparent;
}
body .dx-popup-content .custom-item {
padding-top: 7px;
padding-bottom: 8px;
}
.dx-popup-content .custom-item > div {
padding-left: 8px;
text-indent: 0;
text-overflow: ellipsis;
overflow: hidden;
}
.dx-tag-content {
display: flex;
align-items: center;
}
.tag-img {
height: 30px;
margin-right: 5px;
}
.dx-tag-content.disabled-tag {
padding-right: 6px;
opacity: 0.5;
cursor: not-allowed;
}

DevExtreme v25.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Angular Tag Box - Overview

The TagBox component allows users to select multiple items from a drop-down list.

DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the TagBox features used.
Backend API
<div> <div class="dx-fieldset"> <div class="dx-field"> <div class="dx-field-label">Default mode</div> <div class="dx-field-value"> <dx-tag-box [items]="simpleProducts" [inputAttr]="{ 'aria-label': 'Product' }" ></dx-tag-box> </div> </div> <div class="dx-field"> <div class="dx-field-label">Search mode</div> <div class="dx-field-value"> <dx-tag-box [items]="simpleProducts" [searchEnabled]="true" [inputAttr]="{ 'aria-label': 'Product' }" > </dx-tag-box> </div> </div> <div class="dx-field"> <div class="dx-field-label">Batch selection</div> <div class="dx-field-value"> <dx-tag-box [items]="simpleProducts" [showSelectionControls]="true" applyValueMode="useButtons" [inputAttr]="{ 'aria-label': 'Product' }" > </dx-tag-box> </div> </div> <div class="dx-field"> <div class="dx-field-label">Hide selected items</div> <div class="dx-field-value"> <dx-tag-box [items]="simpleProducts" [hideSelectedItems]="true" [inputAttr]="{ 'aria-label': 'Product' }" > </dx-tag-box> </div> </div> <div class="dx-field"> <div class="dx-field-label">Single line mode</div> <div class="dx-field-value"> <dx-tag-box [items]="simpleProducts" [multiline]="false" [inputAttr]="{ 'aria-label': 'Product' }" > </dx-tag-box> </div> </div> <div class="dx-field"> <div class="dx-field-label">Add custom items</div> <div class="dx-field-value"> <dx-tag-box [items]="editableProducts" [acceptCustomValue]="true" (onCustomItemCreating)="onCustomItemCreating($event)" [inputAttr]="{ 'aria-label': 'Product' }" > </dx-tag-box> </div> </div> <div class="dx-field"> <div class="dx-field-label">With custom placeholder</div> <div class="dx-field-value"> <dx-tag-box [items]="simpleProducts" placeholder="Choose Product..." [inputAttr]="{ 'aria-label': 'Product' }" > </dx-tag-box> </div> </div> <div class="dx-field"> <div class="dx-field-label">Disabled</div> <div class="dx-field-value"> <dx-tag-box [items]="simpleProducts" [value]="[simpleProducts[0]]" [disabled]="true" [inputAttr]="{ 'aria-label': 'Product' }" > </dx-tag-box> </div> </div> <div class="dx-field"> <div class="dx-field-label">Data source</div> <div class="dx-field-value"> <dx-tag-box [dataSource]="dataSource" displayExpr="Name" valueExpr="Id" [inputAttr]="{ 'aria-label': 'Product' }" > </dx-tag-box> </div> </div> <div class="dx-field"> <div class="dx-field-label">Custom template</div> <div class="dx-field-value"> <dx-tag-box [dataSource]="dataSource" [value]="value" displayExpr="Name" valueExpr="Id" itemTemplate="customItem" tagTemplate="customTag" [inputAttr]="{ 'aria-label': 'Product' }" > <div *dxTemplate="let product of 'customItem'"> <div class="custom-item"> <img [src]="product.ImageSrc" [alt]="getAltText(product.Name)" /> <div class="product-name"> {{ product.Name }} </div> </div> </div> <div *dxTemplate="let product of 'customTag'"> <div [ngClass]="{ 'dx-tag-content': true, 'disabled-tag': isDisabled(product) }" [attr.aria-disabled]="isDisabled(product)" (mouseenter)="onMouseEnter($event, product)" (mouseleave)="onMouseLeave()" > <img [src]="product.ImageSrc" [alt]="getAltText(product.Name)" class="tag-img" /> <span>{{ product.Name }}</span> <div *ngIf="!isDisabled(product)" class="dx-tag-remove-button" ></div> </div> </div> </dx-tag-box> <dx-popover [target]="target" [visible]="visible"> <div *dxTemplate="let data of 'content'"> <p> <b>Name: </b><span>{{ product.Name }}</span> </p> <p> <b>Price: </b><span>{{ product.Price }}</span> </p> <p> <b>In-stock: </b><span>{{ product.Current_Inventory }}</span> </p> <p> <b>Category: </b><span>{{ product.Category }}</span> </p> </div> </dx-popover> </div> </div> </div> </div>
import { Component, NgModule, enableProdMode } from '@angular/core'; import { BrowserModule } from '@angular/platform-browser'; import { platformBrowserDynamic } from '@angular/platform-browser-dynamic'; import { DxTagBoxModule, DxPopoverModule, DxTemplateModule } from 'devextreme-angular'; import { ArrayStore } from 'devextreme-angular/common/data'; import { DxTagBoxTypes } from 'devextreme-angular/ui/tag-box'; import { Service, Product } from './app.service'; if (!document.location.host.includes('localhost')) { enableProdMode(); } let modulePrefix = ''; // @ts-ignore if (window && window.config?.packageConfigPaths) { modulePrefix = '/app'; } @Component({ selector: 'demo-app', providers: [Service], templateUrl: `app/app.component.html`, styleUrls: [`app/app.component.css`], }) export class AppComponent { simpleProducts: string[]; editableProducts: string[]; dataSource: ArrayStore; product: Product; value: number[]; target: EventTarget; visible = false; constructor(service: Service) { this.dataSource = new ArrayStore({ data: service.getProducts(), key: 'Id', }); this.simpleProducts = service.getSimpleProducts(); this.editableProducts = this.simpleProducts.slice(); this.value = [1, 2]; } onCustomItemCreating(args: DxTagBoxTypes.CustomItemCreatingEvent) { const newValue = args.text; const isItemInDataSource = this.editableProducts.some((item) => item === newValue); if (!isItemInDataSource) { this.editableProducts.unshift(newValue); } args.customItem = newValue; } onMouseEnter({ target }: MouseEvent, product: Product) { this.target = target; this.product = product; this.visible = true; } onMouseLeave() { this.target = null; this.visible = false; } isDisabled(product: Product) { return product.Name === 'SuperHD Video Player'; } getAltText(text: String) { return `${text}. Picture`; } } @NgModule({ imports: [ BrowserModule, DxTemplateModule, DxTagBoxModule, DxPopoverModule, ], declarations: [AppComponent], bootstrap: [AppComponent], }) export class AppModule { } platformBrowserDynamic().bootstrapModule(AppModule);
body .custom-item { padding-left: 7px; padding-right: 7px; } ::ng-deep .custom-item > img { height: 30px; width: 40px; float: left; margin-top: 2px; } ::ng-deep .custom-item > div.product-name { margin-left: 40px; line-height: 34px; font-size: 14px; } body .custom-item input { background-color: transparent; } body .dx-popup-content .custom-item { padding-top: 7px; padding-bottom: 8px; } ::ng-deep .dx-popup-content .custom-item > div { padding-left: 8px; text-indent: 0; text-overflow: ellipsis; overflow: hidden; } ::ng-deep .dx-tag-content { display: flex; align-items: center; } ::ng-deep .tag-img { height: 30px; margin-right: 5px; } ::ng-deep .dx-tag-content.disabled-tag { padding-right: 6px; opacity: 0.5; cursor: not-allowed; }
import { Injectable } from '@angular/core'; export class Product { Id: number; Name: string; Price: number; Current_Inventory: number; Backorder: number; Manufacturing: number; Category: string; ImageSrc: string; } const simpleProducts = [ 'HD Video Player', 'SuperHD Video Player', 'SuperPlasma 50', 'SuperLED 50', 'SuperLED 42', 'SuperLCD 55', 'SuperLCD 42', 'SuperPlasma 65', 'SuperLCD 70', 'Projector Plus', 'Projector PlusHT', 'ExcelRemote IR', 'ExcelRemote Bluetooth', 'ExcelRemote IP', ]; const products: Product[] = [{ Id: 1, Name: 'HD Video Player', Price: 330, Current_Inventory: 225, Backorder: 0, Manufacturing: 10, Category: 'Video Players', ImageSrc: '../../../../images/products/1.png', }, { Id: 2, Name: 'SuperHD Video Player', Price: 400, Current_Inventory: 150, Backorder: 0, Manufacturing: 25, Category: 'Video Players', ImageSrc: '../../../../images/products/2.png', }, { Id: 3, Name: 'SuperPlasma 50', Price: 2400, Current_Inventory: 0, Backorder: 0, Manufacturing: 0, Category: 'Televisions', ImageSrc: '../../../../images/products/3.png', }, { Id: 4, Name: 'SuperLED 50', Price: 1600, Current_Inventory: 77, Backorder: 0, Manufacturing: 55, Category: 'Televisions', ImageSrc: '../../../../images/products/4.png', }, { Id: 5, Name: 'SuperLED 42', Price: 1450, Current_Inventory: 445, Backorder: 0, Manufacturing: 0, Category: 'Televisions', ImageSrc: '../../../../images/products/5.png', }, { Id: 6, Name: 'SuperLCD 55', Price: 1350, Current_Inventory: 345, Backorder: 0, Manufacturing: 5, Category: 'Televisions', ImageSrc: '../../../../images/products/6.png', }, { Id: 7, Name: 'SuperLCD 42', Price: 1200, Current_Inventory: 210, Backorder: 0, Manufacturing: 20, Category: 'Televisions', ImageSrc: '../../../../images/products/7.png', }, { Id: 8, Name: 'SuperPlasma 65', Price: 3500, Current_Inventory: 0, Backorder: 0, Manufacturing: 0, Category: 'Televisions', ImageSrc: '../../../../images/products/8.png', }, { Id: 9, Name: 'SuperLCD 70', Price: 4000, Current_Inventory: 95, Backorder: 0, Manufacturing: 5, Category: 'Televisions', ImageSrc: '../../../../images/products/9.png', }, { Id: 10, Name: 'DesktopLED 21', Price: 175, Current_Inventory: null, Backorder: 425, Manufacturing: 75, Category: 'Monitors', ImageSrc: '../../../../images/products/10.png', }, { Id: 12, Name: 'DesktopLCD 21', Price: 170, Current_Inventory: 210, Backorder: 0, Manufacturing: 60, Category: 'Monitors', ImageSrc: '../../../../images/products/12.png', }, { Id: 13, Name: 'DesktopLCD 19', Price: 160, Current_Inventory: 150, Backorder: 0, Manufacturing: 210, Category: 'Monitors', ImageSrc: '../../../../images/products/13.png', }, { Id: 14, Name: 'Projector Plus', Price: 550, Current_Inventory: null, Backorder: 55, Manufacturing: 10, Category: 'Projectors', ImageSrc: '../../../../images/products/14.png', }, { Id: 15, Name: 'Projector PlusHD', Price: 750, Current_Inventory: 110, Backorder: 0, Manufacturing: 90, Category: 'Projectors', ImageSrc: '../../../../images/products/15.png', }, { Id: 16, Name: 'Projector PlusHT', Price: 1050, Current_Inventory: 0, Backorder: 75, Manufacturing: 57, Category: 'Projectors', ImageSrc: '../../../../images/products/16.png', }, { Id: 17, Name: 'ExcelRemote IR', Price: 150, Current_Inventory: 650, Backorder: 0, Manufacturing: 190, Category: 'Automation', ImageSrc: '../../../../images/products/17.png', }, { Id: 18, Name: 'ExcelRemote Bluetooth', Price: 180, Current_Inventory: 310, Backorder: 0, Manufacturing: 0, Category: 'Automation', ImageSrc: '../../../../images/products/18.png', }, { Id: 19, Name: 'ExcelRemote IP', Price: 200, Current_Inventory: 0, Backorder: 325, Manufacturing: 225, Category: 'Automation', ImageSrc: '../../../../images/products/19.png', }, ]; @Injectable() export class Service { getProducts(): Product[] { return products; } getSimpleProducts(): string[] { return simpleProducts; } } const productNameLabel = { 'aria-label': 'Product' };
// In real applications, you should not transpile code in the browser. // You can see how to create your own application with Angular and DevExtreme here: // https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/ const componentNames = [ 'accordion', 'action-sheet', 'autocomplete', 'bar-gauge', 'box', 'bullet', 'button-group', 'button', 'calendar', 'card-view', 'chart', 'chat', 'check-box', 'circular-gauge', 'color-box', 'context-menu', 'data-grid', 'date-box', 'date-range-box', 'defer-rendering', 'diagram', 'draggable', 'drawer', 'drop-down-box', 'drop-down-button', 'file-manager', 'file-uploader', 'filter-builder', 'form', 'funnel', 'gallery', 'gantt', 'html-editor', 'linear-gauge', 'list', 'load-indicator', 'load-panel', 'lookup', 'map', 'menu', 'multi-view', 'nested', 'number-box', 'pagination', 'pie-chart', 'pivot-grid-field-chooser', 'pivot-grid', 'polar-chart', 'popover', 'popup', 'progress-bar', 'radio-group', 'range-selector', 'range-slider', 'recurrence-editor', 'resizable', 'responsive-box', 'sankey', 'scheduler', 'scroll-view', 'select-box', 'slider', 'sortable', 'sparkline', 'speed-dial-action', 'splitter', 'stepper', 'switch', 'tab-panel', 'tabs', 'tag-box', 'text-area', 'text-box', 'tile-view', 'toast', 'toolbar', 'tooltip', 'tree-list', 'tree-map', 'tree-view', 'validation-group', 'validation-summary', 'validator', 'vector-map', ]; window.exports = window.exports || {}; window.config = { transpiler: 'ts', typescriptOptions: { module: 'system', emitDecoratorMetadata: true, experimentalDecorators: true, }, meta: { 'typescript': { 'exports': 'ts', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, '@angular/platform-browser-dynamic': { 'esModule': true, }, '@angular/platform-browser': { 'esModule': true, }, '@angular/core': { 'esModule': true, }, '@angular/common': { 'esModule': true, }, '@angular/common/http': { 'esModule': true, }, '@angular/animations': { 'esModule': true, }, '@angular/forms': { 'esModule': true, }, 'openai': { 'esModule': true, }, }, paths: { 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', }, map: { 'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', /* @angular */ '@angular/compiler': 'bundles:@angular/compiler.umd.js', '@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js', '@angular/core': 'bundles:@angular/core.umd.js', '@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js', '@angular/common': 'bundles:@angular/common.umd.js', '@angular/common/http': 'bundles:@angular/common-http.umd.js', '@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js', '@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js', '@angular/forms': 'bundles:@angular/forms.umd.js', /* devextreme */ 'devextreme': 'npm:devextreme@25.1.3/cjs', 'devextreme-quill': 'npm:devextreme-quill@1.7.3/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.19', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.62', /* devextreme-angular umd maps */ 'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js', 'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js', 'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js', 'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js', 'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js', 'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js', 'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js', 'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js', 'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js', 'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js', 'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js', 'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js', 'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js', 'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js', 'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js', 'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js', 'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js', ...componentNames.reduce((acc, name) => { acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`; acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`; return acc; }, {}), 'tslib': 'npm:tslib/tslib.js', 'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js', 'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'app': { main: './app.component.ts', defaultExtension: 'ts', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, 'rxjs': { defaultExtension: 'js', }, 'rxjs/operators': { defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:rxjs@7.5.3/package.json', 'npm:rxjs@7.5.3/operators/package.json', 'npm:devexpress-diagram@2.2.19/package.json', 'npm:devexpress-gantt@4.1.62/package.json', ], }; System.config(window.config); // System.import('@angular/compiler').catch(console.error.bind(console));
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.3/css/dx.light.css" /> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/zone.js@0.14.10/bundles/zone.umd.js"></script> <script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script src="config.js"></script> <script> System.import("app").catch(console.error.bind(console)); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <demo-app>Loading...</demo-app> </div> </body> </html>

This demo illustrates the following TagBox properties:

  • items
    An array of items to display in the drop-down list. Do not use the items property and the dataSource property in the same configuration.

  • dataSource
    Binds the TagBox to a data source, which allows you to perform complex data operations. Do not use the dataSource property and the items property in the same configuration.

  • searchEnabled
    Enables interactive item search.

  • showSelectionControls
    Enables item selection controls.

  • applyValueMode
    Specifies whether TagBox applies the selection instantly or after a confirmation.

  • hideSelectedItems
    Specifies whether TagBox removes selected items from the drop-down list.

  • multiline
    Specifies whether TagBox enables horizontal scrolling when the input field cannot fit all selected items.

  • acceptCustomValue
    Allows users to enter custom values. To enable this capability, implement the onCustomItemCreating handler.

  • placeholder
    Sets the value of the placeholder string.

  • value
    Specifies the list of currently selected items.

  • disabled
    Specifies whether the component responds to user interaction.

  • itemTemplate
    Allows you to customize the appearance and content of list items.

  • tagTemplate Allows you to customize the appearance and content of list item tooltips.

To get started with the DevExtreme TagBox component, refer to the following tutorial for step-by-step instructions: Getting Started with TagBox.